#include <bits/stdc++.h>

using namespace std;

#define MAX 1001

char C[MAX][MAX];
int d1[MAX][MAX], d2[MAX][MAX], h[MAX][MAX], v[MAX][MAX];
int N, M;

int decipher() {
    // reverse iteration, and computation of the max length for each cell moving down or right
    for(int i = N-1; i >= 0; i--) {
        for(int j = M-1; j >= 0; j--) {
            d1[i][j] = d2[i][j] = h[i][j] = v[i][j] = 1;
            if(C[i][j] == C[i+1][j  ]) v[i][j] = max(v[i][j], 1 + v[i+1][j  ]);
            if(C[i][j] == C[i+1][j+1]) d1[i][j] = max(d1[i][j], 1 + d1[i+1][j+1]);
            if(C[i][j] == C[i+1][j-1]) d2[i][j] = max(d2[i][j], 1 + d2[i+1][j-1]);
            if(C[i][j] == C[i  ][j+1]) h[i][j] = max(h[i][j], 1 + h[i  ][j+1]);
        }
    }
    
    // return the max value
    int m = 0;
    for(int i = 0; i < N; i++) for(int j = 0; j < M; j++) {
        if(v[i][j] > m) m = v[i][j];
        if(h[i][j] > m) m = h[i][j];
        if(d1[i][j] > m) m = d1[i][j];
        if(d2[i][j] > m) m = d2[i][j];
    }
    return m;
}


int main() {
    FILE *fr, *fw;

    fr = fopen("input.txt", "r");
    fw = fopen("output.txt", "w");
    assert(2 == fscanf(fr, "%d%d", &N, &M));
    for(int i=0; i<N; i++) {
        assert(1 == fscanf(fr, "%s", C[i]));
    }

    fprintf(fw, "%d\n", decipher());
    fclose(fr);
    fclose(fw);
    return 0;
}
