#include <bits/stdc++.h>

using namespace std;

int main() {
    std::ifstream in("input.txt");
    std::ofstream out("output.txt");
    
    int n;
    in >> n;
    
    int x[n];
    for(int i = 0; i < n; i++) in >> x[i];

    vector<int> tail;
    tail.push_back(x[0]);
    for(int i = 1; i < n; i++) {
        if(x[i] < tail.back()) tail.push_back(x[i]);
        else *lower_bound(tail.begin(), tail.end(), x[i], greater<int>()) = x[i];
    }

    out << tail.size() << std::endl;

/*  or just the quadratic algorithm would be sufficiently fast
    int result = 0;
    int res[n];
    for(int i = 0; i < n; i++) {
        res[i] = 1;
        for(int j = 0; j < i; j++) {
            if(x[i] < x[j]) res[i] = max(res[i], 1 + res[j]);
        }
        result = max(result, res[i]);
    }
    out << result << endl;
*/
    
    return 0;
}
