#include <bits/stdc++.h>

using namespace std;

#define MAXN 100

int n[MAXN];

// essentially, longest increasing subsequence,
// where increasing is interpreted as non-decreasing,
// and we cannot take two consecutive elements

// O(n^2)
int solve(int N) {
    int res = 0;
    int length[N];
    for(int i = 0; i < N; i++) {
        length[i] = 1;
        for(int j = 0; j <= i-2; j++) {
            if(n[j] <= n[i]) length[i] = max(length[i], length[j] + 1);
        }
        res = max(res, length[i]);
    }
    return res;
}




int main() {
    ifstream in("input.txt");
    ofstream out("output.txt");

    int N;    
    in >> N;
    for(int i = 0; i < N; i++) in >> n[i];
    
    out << solve(N) << endl;
    
    return 0;
}
